#property name      "Law of Repetition"
#property copyright " 2009 Stigal"
#property link      "www.stigal.com"

#define major   1
#define minor   0

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1  1


extern int MyBar = 0;

extern int Body.Plus = 70;
extern int Body.Minus = 70;

extern int UpperShadow.Plus = 30;
extern int UpperShadow.Minus = 30;

extern int LowerShadow.Plus = 30;
extern int LowerShadow.Minus = 30;


double candles[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  Comment("");

  SetIndexBuffer(0, candles);
  
  SetIndexEmptyValue(0, 0.0);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexArrow(0, 108);
}

void deinit()
{
  Comment("");
}

void start() 
{
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  if (counted > 0) counted--;
  
  int limit = Bars-counted;
  
  //-----
  
  double dy = 0;
  for (int i=1; i <= 20; i++) 
  {
    dy += 0.3*(High[i]-Low[i])/20;
  }
  
  for (i=MyBar; i < limit; i++) 
  {
    candles[i] = 0.0;
    
    if (Open[MyBar] > Close[MyBar])
    {
      if (Open[i] <= Close[i]) continue;
    }
    
    if (Open[MyBar] < Close[MyBar])
    {
      if (Open[i] >= Close[i]) continue;
    }

    if (Open[MyBar] == Close[MyBar])
    {
      if (Open[i] != Close[i]) continue;
    }

    //-----

    bool A = (MathAbs(Open[MyBar]-Close[MyBar]) - Body.Minus*Point <= MathAbs(Open[i]-Close[i]) && 
              MathAbs(Open[i]-Close[i]) <= MathAbs(Open[MyBar]-Close[MyBar]) + Body.Plus*Point);
    
    bool B = (High[MyBar] - MathMax(Open[MyBar], Close[MyBar]) - UpperShadow.Minus*Point <= High[i] - MathMax(Open[i], Close[i]) && 
              High[i] - MathMax(Open[i], Close[i]) <= High[MyBar] - MathMax(Open[MyBar], Close[MyBar]) + UpperShadow.Plus*Point);
    
    bool C = (MathMin(Open[MyBar], Close[MyBar]) - Low[MyBar] - LowerShadow.Minus*Point <= MathMin(Open[i], Close[i]) - Low[i] && 
              MathMin(Open[i], Close[i]) - Low[i] <= MathMin(Open[MyBar], Close[MyBar]) - Low[MyBar] + LowerShadow.Plus*Point);
    
    if (A && B && C)
    {
      candles[i] = High[i] + dy;
    }
  }
  
  //-----
  
  int count = 0;
  for (i=0; i < Bars; i++)
  {
    if (candles[i] > 0) count++;
  }
  
  Comment("\n  : ", count);
  
}